﻿//DESCRIPTION:Check the active document for duplicate form field names

// Modified 2024-01-23
// Keith Gilbert, Gilbert Consulting
// www.gilbertconsulting.com

Pre();
  
function Pre () {  
	// Check to make sure all required conditions are met
	if (!app.documents.length) { 
		alert("No InDesign documents are open. Please open a document and try again.");
		return;
	}
	Main();
	// app.doScript(Main, undefined, undefined, UndoModes.ENTIRE_SCRIPT,"Run Script");
}  

function Main() {
	var myDoc = app.activeDocument;
	// Build an object of all check boxes, combo boxes, list boxes, signature fields, 
	// and text fields' names and page numbers
	var myObjectsArray = myDoc.allPageItems;
	var myFieldNamesObject = {};
	for (var i=0; i<myObjectsArray.length; i++) {
		var myObject = myObjectsArray[i];
		if ((myObject.constructor.name == "CheckBox") || (myObject.constructor.name == "ComboBox") || (myObject.constructor.name == "ListBox") || (myObject.constructor.name == "SignatureField") || (myObject.constructor.name == "TextBox")) {
			if (myFieldNamesObject[myObject.name] == undefined) {
				myFieldNamesObject[myObject.name] = (Number(myObject.parentPage.documentOffset)+1).toString();
			}
			else {
				var myPageNumberString = myFieldNamesObject[myObject.name]+", "+(Number(myObject.parentPage.documentOffset)+1).toString();
				myFieldNamesObject[myObject.name] = myPageNumberString;
			}
		}
	}
	var myFound = false;
	for (var i in myFieldNamesObject) {
		var myPageNumberString = myFieldNamesObject[i];
		if (myPageNumberString.indexOf(",") != -1) {
			var myPageNumberArray = myPageNumberString.split(", ");
			myPageNumberArray = mySortArray(myPageNumberArray);
			alert("Duplicate field name found: \r"+"'"+i+"'"+" on pages "+myPageNumberArray.join(', '));
			myFound = true;
		}
	}
	if (myFound == false) {
		alert("No duplicate field names found.");
	}
}
// Sort an array (as numbers)
function mySortArray(myArray) {
	myArray = myArray.sort(function(x,y) {
		var a = Number(x);
		var b = Number(y);
		if (a > b)
			return 1
		if (a < b)
			return -1
		return 0;
	})
	return myArray;
}